package b4a.tillekesoft.samsungtv;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.concurrent.TimeoutException;

import android.util.Log;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BA;



@Author("moster67")
@BA.ShortName("RemoteSession")
@Version(1.4f)


public class b4aRemoteSession extends AbsObjectWrapper<RemoteSession> {

	private String applicationName;
	private String uniqueId;
	private String host;
	private int port;
	private String myword; 
	private String b4amyword;
	
	private RemoteSession session;
	
	private static final String TAG = "TAG_B4AWrapper";
	
	
	/**
     * Initialize the RemoteSession object
	 * @throws TimeoutException 
	 * @throws ConnectionDeniedException 
	 * @throws IOException 
     */
    public void Initialize(String b4aapplicationName, String b4auniqueId, String b4ahost, int b4aport) throws IOException, ConnectionDeniedException, TimeoutException{
       	this.applicationName = b4aapplicationName;
		this.uniqueId = b4auniqueId;
		if (uniqueId == null) {
			uniqueId = "";
		}
		this.host = b4ahost;
		this.port = b4aport;;
		this.b4amyword = "anything";
		this.myword = "anything";
		
    	Log.v(TAG,"Initvalues are " + b4aapplicationName + "-" + b4auniqueId + "-" + b4ahost + "-" + b4aport);
    	
        setObject(new RemoteSession(b4aapplicationName, b4auniqueId,b4ahost,b4aport,b4amyword));
        
      
    }

    public void Connect() throws IOException, ConnectionDeniedException, TimeoutException{
        Log.v(TAG,"Connecting");
		RemoteSession.create(applicationName, uniqueId, host, port, myword);
    	
    }
    
       
    public void sendCode(String mykey) throws UnknownHostException, IOException, InterruptedException, ConnectionDeniedException, TimeoutException {
    	Log.v(TAG,"Before sendcode values are " + applicationName + "-" + uniqueId + "-" + host + "-" + port);
    	Log.v(TAG,"Session value is " + session);
    	if ( session == null) Initialize(applicationName, uniqueId, host, port);
			
			if (mykey != null) {
				 Log.v(TAG,"Launching sendkey");
				 getObject().sendKey(mykey);
				
			}
		
	}
    
    
    public void uninitialize() {
		Log.v(TAG, "Uninitializing C-Series Sender...");
		if (session != null) {
			getObject().destroy();
			Log.v(TAG, "...Uninitialized C-Series Sender");
		} else {
			Log.v(TAG, "...Nothing to uninitialize, session is null");
		}
	}

}
